
function [kappa] =my_curv(m,n,i,j,phi,dx,dy)

% phi(m+1,n+1), the level set function, m,n>=3.

    if i == m+1
        phix_r = 3*phi(i,j) - 3*phi(i-1,j) + phi(i-2,j);
        phix_l = phi(i-1,j);
    else
	if i == 1
	  phix_l = 3*phi(i,j) - 3*phi(i+1,j) + phi(i+2,j);
	  phix_r = phi(i+1,j);
	else
	  phix_l = phi(i-1,j);
	  phix_r = phi(i+1,j);
	end
    end
	
      phx = (phix_r - phix_l)/(2*dx);
      phxx = (phix_r + phix_l - 2*phi(i,j) )/(dx*dx);

    if j ==  n + 1
      phiy_r = 3*phi(i,j) - 3*phi(i,j-1) +phi(i,j-2);
      phiy_l = phi(i,j-1); 
    else
      if j == 1
	 phiy_r = phi(i,j+1);
	 phiy_l = 3*phi(i,j) - 3*phi(i,j+1) + phi(i,j+2);
      else
         phiy_r = phi(i,j+1);
         phiy_l = phi(i,j-1);
      end
    end
 
      phy = (phiy_r - phiy_l )/(2*dy);
      phyy = (phiy_r + phiy_l - 2*phi(i,j) )/(dy*dy);
	
      if i > 1
	if j > 1
	  phsw = phi(i-1,j-1);
	end
      end
      if i == 1
	if j > 1
          phsw = 3*phi(i,j-1) - 3*phi(i+1,j-1) + phi(i+2,j-1);
	elseif j == 1
	  phsw = 3*phi(i,j) - 3*phi(i+1,j+1) + phi(i+2,j+2);
	end
      end
      if j == 1 
        if i > 1
          phsw = 3*phi(i-1,j) - 3*phi(i-1,j+1) + phi(i-1,j+2);
        end
      end

      if i < m+1
        if j < n+1
          phne = phi(i+1,j+1);
        end
      end
      if i == m+1
        if j < n+1
          phne = 3*phi(i,j+1) - 3*phi(i-1,j+1) + phi(i-2,j+1);
        elseif j == n+1
          phne = 3*phi(i,j) - 3*phi(i-1,j-1) + phi(i-2,j-2);
        end
      end
      if j == n+1
        if i < m+1
          phne = 3*phi(i+1,j) - 3*phi(i+1,j-1) + phi(i+1,j-2);
        end
      end

      if i < m+1
        if j > 1
          phse = phi(i+1,j-1);
        end
      end
      if i == m+1
        if j > 1
          phse = 3*phi(i,j-1) - 3*phi(i-1,j-1) + phi(i-2,j-1);
        elseif j == 1
          phse = 3*phi(i,j) - 3*phi(i-1,j+1) + phi(i-2,j+2);
        end
      end
      if j == 1
        if i < m+1
          phse = 3*phi(i+1,j) - 3*phi(i+1,j+1) + phi(i+1,j+2);
        end
      end

      if j < n+1
        if i > 1
          phnw = phi(i-1,j+1);
        end
      end
      if j == n+1
        if i > 1
          phnw = 3*phi(i-1,j) - 3*phi(i-1,j-1) + phi(i-1,j-2);
        elseif i == 1
          phnw = 3*phi(i,j) - 3*phi(i+1,j-1) + phi(i+2,j-2);
        end
      end
      if i == 1
        if j < n+1
          phnw = 3*phi(i,j+1) - 3*phi(i+1,j+1) + phi(i+2,j+1);
        end
      end

	phxy = (phsw+phne-phnw-phse)/(4*dx*dy);

        kappa = (phx*phx + phy*phy+1e-8)^1.5;
        kappa = (phy*phy*phxx-2*phx*phy*phxy + phx*phx*phyy)/kappa;

     
