
function [phi_out] = reinit(m,n,dx,dy,phi,width)

%-- This function perfom one step re-initialization ----------
%------- Input information:

   hh = min(dx,dy);
   dt = 0.5*hh;
   phi_new = phi;
   phi_out = phi;
   sign = zeros(m+1,n+1);

   for j=1:n+1
     if j== 1
       jm1 = j;
     else
       jm1=j-1;
     end
     if j== n+1
       jp1 = j;
     else
       jp1=j+1;
     end

     for i=1:m+1,
         if i == 1
          im1=i;
         else
          im1=i-1;
         end
         if i == m+1
          ip1=i;
         else
          ip1=i+1;
         end

         dist=[ abs(phi(im1,j)), abs(phi(ip1,j)), ...
            abs(phi(i,j)), abs(phi(i,jm1)), abs(phi(i,jp1)) ];
	 dis = min(dist);

         if dis < width 
          sign(i,j)=1;
         else
          sign(i,j)=0;
         end

         if abs(phi(i,j)) > width 

          if  phi(i,j) > 0
           phit(i,j)=width + dx;
          else
           phit(i,j)=-width-dx;
          end

         else
          phit(i,j) = phi(i,j);
         end

        end 
     end


      for i=1:n+1,
	  for j=1:n+1,

           if sign(i,j) == 1
	     tmp = abs(phi(i,j));
 	     phi_sign = phi(i,j)/sqrt(phi(i,j)*phi(i,j) + hh);
	     [grad_l, grad_r] = eno2(m,n,i,j,phi,dx,dy);
	     if phi(i,j) < 0
	        grad = grad_l;
	     else
	        grad = grad_r;
	     end
	     phi_new(i,j)=phi(i,j) - dt*phi_sign*(grad-1);
	   else
	     phi_new(i,j)=phit(i,j);
	   end

	  end
      end

      for j=1:n+1
        for i=1:m+1
           if sign(i,j) == 1
	      phi_out(i,j) = phi_new(i,j);
           end
        end
      end
 
 return



