
function [phi_new] = reinit(m,n,dx,dy,phi)

%-- This function perfom one step re-initialization ----------
%------- Input information:

   hh = min(dx,dy);
   dt = 0.5*hh;
   phi_new = phi;

      for i=1:n+1,
	  for j=1:n+1,
 	     phi_sign = phi(i,j)/sqrt(phi(i,j)*phi(i,j) + hh);
	     [grad_l, grad_r] = eno2(m,n,i,j,phi,dx,dy);
	     if phi(i,j) < 0
	        grad = grad_l;
	     else
	        grad = grad_r;
	     end
	     phi_new(i,j)=phi(i,j) - dt*phi_sign*(grad-1);
	  end
      end

 return



